# coding: utf8
# author: zmej74
#import urllib, sys, os, re, time, shutil
import os
import xbmcgui, xbmc

# Коды клавиатурных комманд.
ACTION_PREVIOUS_MENU = 10 # Esc
ACTION_NAV_BACK = 92 # Backspace
ACTION_GREEN = 411 # Green button
ACTION_RED = 410 # red button
ACTION_YELLOW = 412 # yellow button
ACTION_BLUE = 413 # blue button
ACTION_INFO = 117 # info

class editor(xbmcgui.WindowXMLDialog):
    """
    примитивный текстовый редактор строк
    """
    def __init__(self, fxml, scdir, dir1="", dir2=""):
        self.dialog = xbmcgui.Dialog()
        self.filename = ""
        self.flagchange = False
        self.images = {}
        self.strlist_id = 220
        self.filename_id = 300
        self.controls = {}
        self.btn_controls = {"add_line":112, "del_line":114, "save":116, "cancel":118}
        self.strings = []
        self.addon_path = ""
        self.addon = None

    def onInit(self):
        #self.dialog.ok(u'Editor => ', "before load" )
        self.images["bakground"] = os.path.join(self.addon_path, "resources", 'images', 'recentaddedback.png')
        self.images["btnnofocus"] = os.path.join(self.addon_path, "resources", 'images', 'KeyboardKeyNF.png')
        self.images["btnfocus"] = os.path.join(self.addon_path, "resources",'images', 'button-focus2.png')
        self.images["btnfocus2"] = os.path.join(self.addon_path, "resources",'images', 'button-focus.png')
        self.images["icon"] = os.path.join(self.addon_path, "resources",'images', 'notepad.png')
        self.images["frame"] = os.path.join(self.addon_path, "resources",'images', 'dialogback.png')

        self.controls["strlist"] = self.getControl(self.strlist_id)
        self.controls["filename"] = self.getControl(self.filename_id)
        if not self.loadFile():
            self.dialog.ok(self.strlanguage(30025,"Error"), self.strlanguage(30039,"Can't read file!"))
            self.close()
            return False
        self.controls["filename"].addLabel(self.filename)
        self.controls["strlist"].reset()
        self.controls["strlist"].addItems(items=self.strings)
        return True

    def loadFile(self):
        """
        загружает текстовый файл
        """
        if not os.path.isfile(self.filename):
            return False
        ff = open(self.filename,"r")
        #self.dialog.ok(u'Editor => ', ff.readline() )
        self.strings = [one.strip() for one in ff.xreadlines()]
        ff.close()
        #self.dialog.ok(u'Editor => ', self.strings[0] )
        return True

    def writeFile(self):
        """
        записывает строки в файл
        """
        flag = False
        i,cnt = 0, self.controls["strlist"].size()
        if cnt > 0:
            try:
                ff = open(self.filename,"w")
                while i < cnt:
                    ff.write( self.controls["strlist"].getListItem(i).getLabel()+"\n" )
                    i += 1
                ff.close()
                flag =  True
            except:
                flag = False
        return flag

    def editString(self):
        str_beg = self.controls["strlist"].getSelectedItem().getLabel()
        kb = xbmc.Keyboard(str_beg, self.strlanguage(30045,"Editing string"), False)
        kb.doModal()
        #self.dialog.ok("Input","isConfirmed",str(kb.isConfirmed()))
        str_new = kb.getText()
        if (kb.isConfirmed())==1 and (str_new <> str_beg):
            self.controls["strlist"].getSelectedItem().setLabel(str_new)
            #self.dialog.ok("Editing", "Input new data")
            self.flagchange = True
        else:
            #self.dialog.ok("Editing", "Input cancelling")
            pass

    def editBigString(self):
        max_str_size = 50
        str_beg_lst = []
        ret = 0
        str_edit,str_save = "",""
        flag_abort, flag_longstr = False, False
        str_beg = self.controls["strlist"].getSelectedItem().getLabel()
        if len(str_beg) > max_str_size:
            flag_longstr = True
            str_beg_lst = [str_beg[i:i+max_str_size] for i in range(0, len(str_beg), max_str_size)]
            ret = self.dialog.select( self.strlanguage(30058,"Editing long string (50 characters)"), str_beg_lst)
            if ret >= 0:
                str_edit = str_beg_lst[ret]
            else:
                flag_abort = True
        else:
            str_edit = str_beg

        if flag_abort: return

        kb = xbmc.Keyboard(str_edit, self.strlanguage(30045,"Editing string"), False)
        kb.doModal()
        #self.dialog.ok("Input","isConfirmed",str(kb.isConfirmed()))
        str_new = kb.getText()
        if (kb.isConfirmed())==1 and (str_new <> str_edit):
            if flag_longstr:
                str_beg_lst[ret] = str_new
                str_save = "".join( [one for one in str_beg_lst] )
            else:
                str_save = str_new
            self.controls["strlist"].getSelectedItem().setLabel(str_save)
            #self.dialog.ok("Editing", "Input new data")
            self.flagchange = True
        else:
            #self.dialog.ok("Editing", "Input cancelling")
            pass

    def addString(self):
        """
        добавляет пустую строку в список
        """
        del self.strings[:]
        i,cnt = 0, self.controls["strlist"].size()
        cur_row = self.controls["strlist"].getSelectedPosition()
        while i < (cnt):
            self.strings.append(self.controls["strlist"].getListItem(i).getLabel())
            if i == cur_row:
                self.strings.append("")
            i += 1
        self.controls["strlist"].reset()
        self.controls["strlist"].addItems(items=self.strings)
        #for one in self.strings:
        #    lone = xbmcgui.ListItem(one, "" )
        #    self.controls["strlist"].addItem(lone)
        #del self.strings[:]
        self.controls["strlist"].selectItem(cur_row+1)
        self.flagchange = True

    def delString(self):
        """
        удаляет текущую строку
        """
        del self.strings[:]
        i,cnt = 0, self.controls["strlist"].size()
        cur_row = self.controls["strlist"].getSelectedPosition()
        while i < cnt:
            if i <> cur_row:
                self.strings.append(self.controls["strlist"].getListItem(i).getLabel())
            i += 1
        self.controls["strlist"].reset()
        self.controls["strlist"].addItems(items=self.strings)
        #for one in self.strings:
        #    lone = xbmcgui.ListItem(one, "" )
        #    self.controls["strlist"].addItem(lone)
        #del self.strings[:]
        cur_row = (cur_row-1) if (cur_row >= self.controls["strlist"].size()-1 ) else cur_row
        self.controls["strlist"].selectItem(cur_row)
        self.flagchange = True

    def exitsave(self):
        if self.flagchange and (not self.writeFile()):
            self.dialog.ok(self.strlanguage(30025,"Error"), self.strlanguage(30046,"Can't save the file!"))
        else:
            self.close()

    def exitcancel(self):
        if self.flagchange:
            if self.dialog.yesno("",self.strlanguage(30047,"Data was changed!"), self.strlanguage(30048,"Do you want to save?")):
                self.exitsave()
        self.close()

    def onAction(self, action):
        # Обрабатываем нажатия кнопок для выхода из плагина.
        c_id = 0
        if action == ACTION_NAV_BACK or action == ACTION_PREVIOUS_MENU:
            #self.close()
            c_id = self.btn_controls["cancel"]
        elif action == ACTION_GREEN:
            c_id = self.btn_controls["save"]
        elif action == ACTION_RED:
            c_id = self.btn_controls["cancel"]
        elif action == ACTION_YELLOW:
            c_id = self.btn_controls["add_line"]
        elif action == ACTION_BLUE:
            c_id = self.btn_controls["del_line"]
        elif action == ACTION_INFO:
            self.editBigString()
        if c_id <> 0:
            self.doClickAction(c_id)

    def onClick(self, c_id):
        #self.dialog.ok("","id control = %s"%c_id) #
        self.doClickAction(c_id)

    def doClickAction(self, control_id):
        # Обрабатываем активированные контролы.
        if control_id == self.strlist_id:
            self.editString()
            #
        elif control_id == self.btn_controls["add_line"]:
            self.addString()
            self.setFocus(self.controls["strlist"])
        elif control_id == self.btn_controls["del_line"]:
            self.delString()
            self.setFocus(self.controls["strlist"])
        elif control_id == self.btn_controls["save"]:
            self.exitsave()
        elif control_id == self.btn_controls["cancel"]:
            self.exitcancel()

    def set_navigation(self):
        pass

    def strlanguage(self, id_str, altstr=""):
        #self.logout("lang= %s, id_str= %s, altstr= %s"%(xbmc.getLanguage(),id_str,altstr))
        onestr = ""
        try:
            #onestr = self.addon.getLocalizedString( id=id_str )
            onestr = self.addon.getLocalizedString( id_str )
        except:
            onestr = ""
        #self.logout("onestr= %s, id_str= %s, altstr= %s"%(onestr,id_str,altstr))
        if onestr:
            return onestr
        else:
            return altstr