# -*- coding: utf-8 -*-
# author: zmej74
# Имортируем модули стандартной библиотеки.
import os, sys
# Импортируем модули XBMC.
import xbmcgui, xbmcaddon, xbmc
import threading
import emulogreader
#import editor, emuinfo

# Создаем экземпляр класса Addon для доступа к параметрам плагина.
# Если имя плагина в xbmcaddon.Addon() явно не указано,
# мы получаем параметры текущего плагина.
_addon = xbmcaddon.Addon()
# Получаем путь к плагину.
_addon_path = _addon.getAddonInfo('path').decode(sys.getfilesystemencoding())

# Коды клавиатурных комманд.
ACTION_PREVIOUS_MENU = 10 # Esc
ACTION_NAV_BACK = 92 # Backspace
ACTION_GREEN = 411 # Green button
ACTION_RED = 410 # red button
ACTION_YELLOW = 412 # yellow button
ACTION_BLUE = 413 # blue button
ACTION_INFO = 117 #
# Параметр выравнивания текста.
ALIGN_CENTER = 6

class EmuWindow(xbmcgui.WindowXMLDialog):

    def __init__(self, fxml, scdir, dir1="", dir2=""):
        # Создаем экземпляр класса Dialog для доступа к диалогам.
        self.dialog = xbmcgui.Dialog()
        self.addon = None
        self.addon_path = ""
        self.emu_manager = None
        self.controls = {}
        self.emulist_id = 220
        self.btnlist_id = 230
        self.btn_controls = {"start":112, "stop":114, "restart":116, "editor":118, "exit":120, "remove":122,
                             "change_path":124, "log":126, "load":128, "exclude":130,  "settings":132, "info":134}
        self.ecminfo_controls = {"caid":320, "prov": 322, "pid":324, "chid":326, "reader":328, "protocol":330,
                                 "from":332, "port":334, "ecm time":336, "cw0":338, "cw1":340}
        self.status_controls = {"emu_name":300, "emu_path":302}
        self.images = {}
        self.flagExit = False
        self.lockobj = threading.Lock()     #блокировщиц для совместного буффера
        self.buff_log_size = 300            # размер лога сообщений на экране
        self.buff_log_msg = []              # буффер сообщений лога
        self.emulogobj = emulogreader.emulogreader()

    def onInit(self):
        #self.images["emurun"] = os.path.join(self.addon_path, "resources",'images', 'emuact.png')
        #self.images["emunorun"] = os.path.join(self.addon_path, "resources",'images', 'emumini.png')
        self.images["emurun"] = os.path.join(self.addon_path, "resources/skins/Default",'media', 'radiobutton_on.png')
        self.images["emunorun"] = os.path.join(self.addon_path, "resources/skins/Default",'media', 'radiobutton.png')
        self.controls["emulist"] = self.getControl(self.emulist_id)
        self.rebuildList(True)
        #self.ecmRefresh(self.emu_manager.infoEcm())
        self.startemulog()


    def fillControls(self):
        pass
        #

    def ecmRefresh(self, ecminfo):
        """
        обновляет контролы с данными о ECM
        """
        for (k,c_id) in self.ecminfo_controls.items():
            v = self.getControl(c_id)
            v.reset()
            if len(ecminfo) > 0:
                v.addLabel(ecminfo.get(k,""))
            else:
                v.addLabel("...")

    def statusRefresh(self, numitem):
        i = 0
        while i < self.controls["emulist"].size():
            self.controls["emulist"].getListItem(i).setLabel2("")
            self.controls["emulist"].getListItem(i).setIconImage(self.images["emunorun"])
            i += 1
        #self.dialog.ok(u"",u"Set all norun ")
        for c_id in self.status_controls.values():
            v = self.getControl(c_id)
            v.reset()
        #self.dialog.ok(u"Выбор",u"Clear status")
        ename = self.getControl(self.status_controls["emu_name"])
        epath = self.getControl(self.status_controls["emu_path"])
        if numitem >= 0:
            self.controls["emulist"].getListItem(numitem).setLabel2("[COLOR FFFFFF00]%s[/COLOR]" % self.strlanguage(30023, u"is working!"))
            self.controls["emulist"].getListItem(numitem).setIconImage(self.images["emurun"])
            ename.addLabel(self.emu_manager.emus[numitem].emu_name)
            epath.addLabel(self.emu_manager.emus[numitem].config_path)
        else:
            ename.addLabel(" ")
            epath.addLabel(" ")

    def rebuildList(self,  firstStart = False):
        self.controls["emulist"].reset()
        numact = -1
        emulist = []
        cnt = range(len(self.emu_manager.emus))
        for i in cnt:
            one = self.emu_manager.emus[i]
            lone = xbmcgui.ListItem(one.emu_name, "" , self.images["emunorun"])
            emulist.append(lone)
        self.controls["emulist"].addItems(items=emulist)
        if firstStart: xbmc.sleep(1500)
        for i in cnt:
            if os.name == "posix" and self.emu_manager.emus[i].emu_running():
                numact = i
                self.statusRefresh(numact)
                self.controls["emulist"].selectItem(numact)

        
    def onAction(self, action):
        # Обрабатываем нажатия кнопок для выхода из плагина.
        c_id = 0
        if action == ACTION_NAV_BACK or action == ACTION_PREVIOUS_MENU:
            c_id = self.btn_controls["exit"]
        elif action == ACTION_GREEN:
            c_id = self.btn_controls["start"]
        elif action == ACTION_RED:
            c_id = self.btn_controls["stop"]
        elif action == ACTION_YELLOW:
            c_id = self.btn_controls["restart"]
        elif action == ACTION_BLUE:
            c_id = self.btn_controls["exit"]
        elif action == ACTION_INFO:
            c_id = self.btn_controls["info"]
        if c_id <> 0:
            self.onControlId(c_id)

    def onClick(self, c_id):
        self.onControlId(c_id)


    def onControlId(self, control_id):
        # Обрабатываем активированные контролы.
        pos = self.controls["emulist"].getSelectedPosition()
        # нажатие Ок на текущей позици списка
        if control_id == self.emulist_id:
            if os.name == "posix":
                self.stopemulog()
                if self.emu_manager.emus[pos].emu_running():
                    self.emu_manager.stopEmu()
                    self.statusRefresh(-1)
                else:
                    self.statusRefresh(-1)
                    if not self.isLogAuthorization(): self.startemulog()
                    self.emu_manager.startEmu( self.emu_manager.emus[pos].emu_id )
                    if self.emu_manager.emus[pos].emu_running():
                        self.statusRefresh(pos)
                        if self.isLogAuthorization(): self.startemulog()
                self.ecmRefresh( self.emu_manager.infoEcm() )
            else:
                self.statusRefresh( self.controls["emulist"].getSelectedPosition() )
        # выбор кнопки Старт в меню - старт эмулятора
        elif control_id == self.btn_controls["start"]:
            if os.name == "posix":
                if not self.emu_manager.emus[pos].emu_running():
                    self.statusRefresh(-1)
                    self.stopemulog()
                    if not self.isLogAuthorization(): self.startemulog()
                    self.emu_manager.startEmu( self.emu_manager.emus[pos].emu_id )
                    if self.emu_manager.emus[pos].emu_running():
                        self.statusRefresh(pos)
                        if self.isLogAuthorization(): self.startemulog()
                    self.ecmRefresh( self.emu_manager.infoEcm() )
                self.setFocus(self.controls["emulist"])
        # выбор кнопки Стоп в меню - остановка эмулятора
        elif control_id == self.btn_controls["stop"]:
            if os.name == "posix":
                self.stopemulog()
                self.emu_manager.stopEmu()
                self.statusRefresh(-1)
                self.ecmRefresh( self.emu_manager.infoEcm() )
                self.setFocus(self.controls["emulist"])
        # выбор кнопки Рестарт в меню - перезапуск (остановка+старт) текущего эмулятора
        elif control_id == self.btn_controls["restart"]:
            if os.name == "posix":
                if self.emu_manager.emus[pos].emu_running():
                    self.stopemulog()
                    self.emu_manager.stopEmu()
                    self.ecmRefresh( self.emu_manager.infoEcm() )
                    if not self.isLogAuthorization(): self.startemulog()
                    self.emu_manager.startEmu( self.emu_manager.emus[pos].emu_id )
                    if self.emu_manager.emus[pos].emu_running():
                        self.statusRefresh(pos)
                        if self.isLogAuthorization(): self.startemulog()
                    else:
                        self.statusRefresh(-1)
                    self.ecmRefresh( self.emu_manager.infoEcm() )
                self.setFocus(self.controls["emulist"])
        # выбор кнопки Редактор в меню - вызов формы для редактирования файла
        elif control_id == self.btn_controls["editor"]:
            fname = self.dialog.browse(1, self.strlanguage(30024,"Text file"), "files", "")
            if fname <> "":
                import editor
                edit = editor.editor('softcam_editor.xml', self.addon_path)
                edit.addon = self.addon
                edit.addon_path = self.addon_path
                edit.filename = fname
                edit.doModal()
                del edit
        # выбор кнопки Загрузка в меню - установка нового эмулятора
        elif control_id == self.btn_controls["load"]:
            try:
                if self.emu_manager.emufromzip():
                    self.rebuildList()
                    self.setFocus(self.controls["emulist"])
            except Exception as msg:
                self.dialog.ok(self.strlanguage(30025,"Error"), self.strlanguage(30037,"Unknown error"))
        # выбор кнопки Исключить в меню - удаление эмулятора из списка
        elif control_id == self.btn_controls["exclude"]:
            pos = self.controls["emulist"].getSelectedPosition()
            if self.dialog.yesno(self.strlanguage(30026,"Attention"), self.strlanguage(30027,"Do you want to exclude"), self.emu_manager.emus[pos].emu_name):
                if self.emu_manager.emus[pos].emu_running(): self.stopemulog()
                if self.emu_manager.deleteOneEMU(pos):
                    self.rebuildList()
                    self.setFocus(self.controls["emulist"])
        # выбор кнопки Изменить путь в меню - смена конфигурационных файлов для эмулятора
        elif control_id == self.btn_controls["change_path"]:
            self.emu_manager.changeConfigPath(pos)
            self.setFocus(self.controls["emulist"])
        # выбор кнопки Удалить в меню - остановка и удаление из ресивера выделенного эмулятора (в списке остается)
        elif control_id == self.btn_controls["remove"]:
            if os.name == "posix":
                self.stopemulog()
                self.emu_manager.removeEmu()
                self.statusRefresh(-1)
                self.setFocus(self.controls["emulist"])
        # выбор кнопки Инфо в меню или (Info) на пульте - вызов окна с информацией об эмуляторе
        elif control_id == self.btn_controls["info"]:
            import emuinfo
            info = emuinfo.emuinfo('softcam_info.xml', self.addon_path)
            info.addon = self.addon
            info.addon_path = self.addon_path
            info.emu = self.emu_manager.emus[pos]
            info.doModal()
            del info
            self.setFocus(self.controls["emulist"])
        # выбор кнопки Настройки в меню - вызов окна настроек аддона
        elif control_id == self.btn_controls["settings"]:
            self.addon.openSettings()
            self.refreshLogPar()
        # выбор кнопки Лог в меню - выод окна с отображением лога эмулятора
        elif control_id == self.btn_controls["log"]:
            import loggui
            lg = loggui.logwindow('softcam_logview.xml', self.addon_path)
            lg.addon = self.addon
            lg.addon_path = self.addon_path
            lg.emuwindow = self
            lg.split_row = True if self.readsetting("emulog_split_row") == 'true' else False
            self.refillLogBuffer()
            lg.doModal()
            del lg
        # выбор кнопки Выход в меню или (Back) на пульте - выход из аддона
        elif control_id == self.btn_controls["exit"]:
            self.close()

    def close(self):
        """переопределение метода close"""
        self.stopemulog()
        self.flagExit = True
        xbmcgui.WindowXMLDialog.close(self)

    def strlanguage(self, id_str, altstr=""):
        try:
            onestr = self.addon.getLocalizedString( id_str )
        except:
            onestr = ""
        if onestr:
            return onestr
        else:
            return altstr
    
    def readsetting(self, parname):
        """
        читает параметры аддона
        """
        return self.addon.getSetting(parname)
    
    def startemulog(self):
        """ инициализирует и запускает чтение лога"""
        self.emulogobj.host = self.readsetting("emulog_ip")
        self.emulogobj.port = int(self.readsetting("emulog_port"))
        self.emulogobj.user = self.readsetting("emulog_user")
        self.emulogobj.password = self.readsetting("emulog_psw")
        self.emulogobj.addevent = self.onReadLogEvent
        del self.buff_log_msg[:]
        if self.emulogobj.connect():
            self.emulogobj.startread()
    
    def stopemulog(self):
        """останавливает чтение лога"""
        self.emulogobj.stopread()
        xbmc.sleep(1000)
        self.emulogobj.close()
        
    def onReadLogEvent(self, msgs):
        """выполняется при каждом чтении лога"""
        while self.lockobj.locked():
            xbmc.sleep(500)
        self.lockobj.acquire(True)
        if len(self.buff_log_msg) > self.buff_log_size:
            self.buff_log_msg.pop(0)
        self.buff_log_msg.append( msgs[-1] )
        self.lockobj.release()
 
    def isLogAuthorization(self):
        """возращает True если для чтения лога задана авторизация"""
        return True if self.emulogobj.host else False
        
    def refreshLogPar(self):
        """проверяет изменение параметров считывания лога - адрес, порт, логин, пароль"""
        flag = False
        host = self.readsetting("emulog_ip")
        port = int(self.readsetting("emulog_port"))
        user = self.readsetting("emulog_user")
        password = self.readsetting("emulog_psw")
        if ( host != self.emulogobj.host ) or ( port != self.emulogobj.port ) \
            or ( user != self.emulogobj.user ) or ( password != self.emulogobj.password ):
            self.stopemulog()
            self.emulogobj.host = host
            self.emulogobj.port = port
            self.emulogobj.user = user
            self.emulogobj.password = password
            self.startemulog()
    
    def refillLogBuffer(self):
        """принудительно заполняет буффер лога если он пуст, а сообщения есть"""
        if True or (len(self.buff_log_msg) == 0 and len(self.emulogobj.log_messages) > 0):
            self.buff_log_msg = self.emulogobj.log_messages[-self.buff_log_size:]
