# -*- coding: utf-8 -*-

import socket
import sys
import time
import threading
reload(sys)
sys.setdefaultencoding("utf-8")

class emulogreader():
    """ читает логи ємуляторов (oscam, wicardd, mgcamd) """
    def __init__(self):
        self.host = "127.0.0.1"
        self.port = 988
        self.buffsize = 4096
        self.user = ""
        self.password = ""
        self.log_messages = []  # список сообщений лога
        self.msg_count = 1000   # кол=во хранимых сообщений
        self.udpsock = None
        self.addevent = None    # callback function on add message event
        self.loginflag = False
        self.beforeclosecmd = []
        self.flag_abort_reading = False
        self.processreading = None  # threading процесс чтения сообщений
        self.readinterval = 1
        
    def connect(self):
        self.udpsock = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
        self.udpsock.settimeout(5)
        try:
            if self.user and self.password:
                self.udpsock.connect( (self.host, self.port) )
            else:
                self.udpsock.bind( (self.host, self.port) )
            retval = True
        except:
            retval = False
        logincommand = 'login %s %s'    # oscam login command = login user password
        answerlogin = "[AS0000]1|%s logged in" % self.user  # oscam answer
        if retval and self.user and self.password:
            # если заданы логин и пароль, то подключаемся к оскам
            try:
                self.udpsock.sendall(logincommand % (self.user, self.password))
                ans = self.udpsock.recv(self.buffsize).strip()
                if ans == answerlogin:
                    #print "login correct"
                    retval = True
                    self.loginflag = True
                    self.udpsock.sendall("log on")
                    self.beforeclosecmd.append("log off")
                    self.beforeclosecmd.append("exit")                    
                else:
                    retval = False
            except:
                retval = False
        return retval
        
    def close(self):
        """ закрывает соединение """
        if self.udpsock:
            if len(self.beforeclosecmd)>0:
                for one in self.beforeclosecmd: self.udpsock.sendall(one)
            self.udpsock.close()
            self.udpsock = None
            del self.log_messages[:]
            del self.beforeclosecmd[:]
    
    def reconnect(self):
        """ переподключается к сокету"""
        self.close()
        return self.connect()
    
    def readmessages(self):
        """читает сообщения из сокета и добавляет их в список"""
        #print "Start Reading"
        self.udpsock.settimeout(1)
        data = ""
        while not self.flag_abort_reading:
            try:
                data = self.udpsock.recv(self.buffsize)
                time.sleep(0.1)
                #str1 = data.decode()
                str1 = data
                if len(self.log_messages) >= self.msg_count:
                    self.log_messages.pop(0)
                self.log_messages.append(str1.strip('\n\0'))
                if self.addevent:
                    self.addevent(self.log_messages)
            except socket.timeout:
                pass
        #print "Stop Reading"
        
    def startread(self):
        """запускает чтения из сокета в отдельном потоке"""
        self.flag_abort_reading = False
        self.processreading = threading.Thread(target=self.readmessages)
        self.processreading.start()
    
    def stopread(self):
        """останавливает процесс чтения"""
        self.flag_abort_reading = True

# код тестирования
__messages = []
__lock = threading.Lock()
def call_func(msgs):
    global __messages
    #cnt = 5
    #i = 0
    while __lock.locked():
        time.sleep(1)
    __lock.acquire(True)
    str1 = msgs[-1]
    #print "[[[CALL]]] ", str1
    __messages.append(str1)
    #print "[[[CALL]]] ", 
    __lock.release()

def show_msg():
    global __messages
    while __lock.locked():
        time.sleep(1)    
    __lock.acquire(True)
    for one in __messages:
        print one
    del __messages[:]
    __lock.release()
        
if __name__ == '__main__':
    cl = emulogreader()
    cl.host = "192.168.1.40"
    cl.port = 988
    cl.user = "root"
    cl.password = "dreambox"
    cl.addevent = call_func
    if cl.connect():
        cl.startread()
        for one in range(10):
            show_msg()
            time.sleep(1)
        cl.stopread()
        cl.close()
    time.sleep(10)
    
    
