# coding: utf8
# author: zmej74
import mechanize
import cookielib
import os, shutil
import xbmcgui

SOURCE_URL = 0
SOURCE_FILE = 1

class keysdownloader():
    """
    класс реализующий загрузку и обработку файлов ключей с источников в интернете
    """    
    def __init__(self):
        self.tasks = {"softcamkey":
                                {"sourcetype":SOURCE_URL, "url":'http://freecolor.eu.org/keys/SoftCam.Key', "file":'', 
                                "tmpfile":(os.path.join('c:/temp', 'sck.tmp') if os.name == "nt" else "/tmp/sck.tmp"), 
                                "realname":'SoftCam.Key', "path":[], "istext":True, "delcomment":True,  "enable":True, "result":False}, 
                            "constantcw":
                                {"sourcetype":SOURCE_URL, "url":'http://freecolor.eu.org/keys/constant.cw',  "file":'',
                                "tmpfile":(os.path.join('c:/temp', 'ccw.tmp') if os.name == "nt" else "/tmp/ccw.tmp"), 
                                "realname":'constant.cw', "path":[], "istext":True, "delcomment":True,  "enable":True, "result":False}
                        }
        self.browser = mechanize.Browser()
        self.cookieJar = cookielib.LWPCookieJar()
        self.browser.set_cookiejar(self.cookieJar)
        self.browser.set_handle_equiv(True)
        #br.set_handle_gzip(True)
        self.browser.set_handle_redirect(True)
        self.browser.set_handle_referer(True)
        self.browser.set_handle_robots(False)
        self.browser.set_handle_refresh(mechanize._http.HTTPRefreshProcessor(), max_time=1)
        self.browser.addheaders = [('User-agent', 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.1) Gecko/2008071615 Fedora/3.0.1-1.fc9 Firefox/3.0.1')]
        self.maxsize = 200000
        self.hook = None
        self.enableXBMCprogress = False
        self.XBMCprogress = None
        self.XBMCprogress_message = ["Downloading complete", "Error downloading"]
        self.current_file = ""
    
    def downloadKeys(self,  onetask):
        """
        выполняет загрузку и сохранение файлов согласно шаблона
        """
        fdn = ""
        fnames = [os.path.join(one, onetask["realname"]) for one in onetask["path"]]
        files = []
        tempstr = ""
        try:
            if onetask["sourcetype"] == SOURCE_URL:
                try:
                    fdn = self.browser.retrieve(onetask["url"], onetask["tmpfile"],  self.hook)[0]
                except NameError,  x:
                    print x
                    #if x != NameError("Too big file"):
                    #   raise NameError(x)
                except:
                    raise NameError("Other_error")
                if os.path.isfile(fdn):
                    onetask["result"] = True
                    ff = open(fdn,  "rb")
                    files = [open(one, 'wb') for one in fnames]
                    if onetask["istext"] and onetask["delcomment"]:
                        strs = [onestr for onestr in ff.xreadlines() if onestr[0] != '#']                        
                    else:
                        strs = [onestr for onestr in ff.xreadlines()]                                                
                    for onef in files:
                        onef.writelines(strs)
                        onef.close()
                    ff.close()
                    os.remove(fdn)
            elif onetask["sourcetype"] == SOURCE_FILE:
                fdn = onetask["file"]
                if os.path.isfile(fdn):
                    onetask["result"] = True
                    for one in fnames:
                        shutil.copy(fdn, one)
                        onetask["result"] = ( os.path.isfile(one) and onetask["result"]) 
        except:
            pass
    
    def default_hooker(self, blocknum, bs, size):
        """
        обработчик по-умолчанию во время загрузки файлов
        """        
        if size > self.maxsize:
            raise NameError("Too_big_file")

    def XBMC_hooker(self, blocknum, bs, size):
        """
        обработчик с выводом диалога XBMC во время загрузки файлов
        """        
        if size > self.maxsize:
            raise NameError("Too_big_file")
    def run_process(self):
        """
        запускает обработку заданий по загрузке файлов
        """                  
        if self.hook == None:
            self.hook = self.default_hooker
        for onet in self.tasks.values():
            if onet["enable"]:
                self.current_file = onet["realname"]
                self.downloadKeys(onet)
                if self.enableXBMCprogress:
                    if onet["result"]:
                        xbmcgui.Dialog().notification(onet["realname"], self.XBMCprogress_message[0], xbmcgui.NOTIFICATION_INFO, 2000)
                    else:
                        xbmcgui.Dialog().notification(onet["realname"], self.XBMCprogress_message[1], xbmcgui.NOTIFICATION_ERROR, 2000)
        self.current_file = ""
if __name__ == "__main__":
    """
    tst = keysdownloader()
    tst.tasks["softcamkey"]["path"].append('c:/temp')
    tst.tasks["constantcw"]["path"].append('c:/temp')
    tst.tasks["ee36bin"]["path"].append('c:/temp')
    tst.tasks["ee56bin"]["path"].append('c:/temp')
    tst.tasks["constantcw"]["enable"] = False
    tst.tasks["ee36bin"]["enable"] = False
    tst.tasks["ee56bin"]["enable"] = False
    tst.tasks["softcamkey"]["delcomment"] = False
    #tst.hook = hooker
    #for onet in tst.tasks.values():
    #   tst.downloadKeys(onet)
    tst.run_process()
    """
    pass
