# coding: utf8
# author: zmej74
#import urllib, sys, os, re, time, shutil
import os
import xbmcgui, xbmc
import threading
import datetime


# Коды клавиатурных комманд.
ACTION_PREVIOUS_MENU = 10 # Esc
ACTION_NAV_BACK = 92 # Backspace
ACTION_GREEN = 411 # Green button
ACTION_RED = 410 # red button
ACTION_YELLOW = 412 # yellow button
ACTION_BLUE = 413 # blue button
ACTION_INFO = 117 # info

MAX_LENGTH_STRING = 98     # максимальная длина строки отображаемой в окне
START_SYMS = "  "           # стартовые символы отрезаемой строки

class logwindow(xbmcgui.WindowXMLDialog):
    """
    отображение лога эмулятора
    """
    def __init__(self, fxml, scdir, dir1="", dir2=""):
        self.dialog = xbmcgui.Dialog()
        self.filename = ""
        self.flagchange = False
        self.images = {}
        self.strlist_id = 220
        self.ip_id = 300
        self.controls = {}
        self.btn_controls = {"stop_log":112, "start_log":114, "save":116, "exit":118}
        self.strings = []
        self.addon_path = ""
        self.addon = None
        self.emuwindow = None           # ссылка на объект главного окна EmuWindow
        self.updateinterval = 2         # интервал обновления в секундах
        self.refreshtimer = None
        self.split_row = False          # признак разбиения строки
        
        self.read_count = 0
        
    def onInit(self):
        #self.dialog.ok(u'Editor => ', "before load" )
        self.images["bakground"] = os.path.join(self.addon_path, "resources", 'images', 'recentaddedback.png')
        self.images["btnnofocus"] = os.path.join(self.addon_path, "resources", 'images', 'KeyboardKeyNF.png')
        self.images["btnfocus"] = os.path.join(self.addon_path, "resources",'images', 'button-focus2.png')
        self.images["btnfocus2"] = os.path.join(self.addon_path, "resources",'images', 'button-focus.png')
        self.images["icon"] = os.path.join(self.addon_path, "resources",'images', 'notepad.png')
        self.images["frame"] = os.path.join(self.addon_path, "resources",'images', 'dialogback.png')

        self.controls["strlist"] = self.getControl(self.strlist_id)
        self.controls["title"] = self.getControl(self.ip_id)
        self.controls["title"].addLabel("%s:%s" % (self.emuwindow.emulogobj.host, self.emuwindow.emulogobj.port) )
        
        self.controls["strlist"].reset()
        self.startLog()
        return True

    def startLog(self):
        """запускает чтение лога"""
        self.readLog()        
        if not self.refreshtimer:
            self.refreshtimer = threading.Timer(self.updateinterval, self.readLog)
            self.refreshtimer.start()

    def stopLog(self):
        """запускает чтение лога"""
        if self.refreshtimer:
            self.refreshtimer.cancel()

    def readLog(self):
        """чтение лога"""
        while self.emuwindow.lockobj.locked():
            xbmc.sleep(500)
        self.emuwindow.lockobj.acquire(True)
        strs = []
        for one in self.emuwindow.buff_log_msg:
            if self.split_row:
                strs_one = [(one[i:i+MAX_LENGTH_STRING] if i==0 else START_SYMS+one[i:i+MAX_LENGTH_STRING])
                            for i in xrange(0, len(one), MAX_LENGTH_STRING)]
                strs.extend(strs_one)
            else:
                strs.append(one)
        for onestr in strs:
            if self.controls["strlist"].size() > self.emuwindow.buff_log_size:
                self.controls["strlist"].removeItem(0)
            self.controls["strlist"].addItem(onestr)
        del self.emuwindow.buff_log_msg[:]
        del strs[:]
        self.controls["strlist"].selectItem( self.controls["strlist"].size()-1 )
        self.emuwindow.lockobj.release()
        if self.refreshtimer:
            self.refreshtimer = threading.Timer(self.updateinterval, self.readLog)
            self.refreshtimer.start()
        
    def writeFile(self):
        """
        записывает лог в файл
        пишется исходный буфер, который будет больше
        """
        flag = False
        cnt = self.controls["strlist"].size()
        if cnt > 0:
            try:
                fld = xbmcgui.Dialog().browse(0, self.strlanguage(30132,"Folder to save"), "files", "")
                if fld <> "":
                    curDate = datetime.datetime.now()
                    fname = curDate.strftime("emu%Y%m%d_%H%M%S.log")
                    fullname = os.path.join( fld, fname)
                    try:
                        ff = open(fullname,"w")
                        for one in self.emuwindow.emulogobj.log_messages:
                            ff.write( one+"\n" )
                        ff.close()
                        xbmcgui.Dialog().notification( self.strlanguage(30131,"File created"), fname )
                        flag =  True
                    except:
                        pass
            except:
                flag = False
        return flag

    def close(self):
        """переопределение метода close"""
        self.stopLog()
        self.refreshtimer = None
        xbmcgui.WindowXMLDialog.close(self)

    def onAction(self, action):
        # Обрабатываем нажатия кнопок для выхода из плагина.
        c_id = 0
        if action == ACTION_NAV_BACK or action == ACTION_PREVIOUS_MENU:
            #self.close()
            c_id = self.btn_controls["exit"]
        elif action == ACTION_GREEN:
            c_id = self.btn_controls["save"]
        elif action == ACTION_RED:
            c_id = self.btn_controls["exit"]
        elif action == ACTION_YELLOW:
            c_id = self.btn_controls["stop_log"]
        elif action == ACTION_BLUE:
            c_id = self.btn_controls["start_log"]
        if c_id <> 0:
            self.doClickAction(c_id)

    def onClick(self, c_id):
        #self.dialog.ok("","id control = %s"%c_id) #
        self.doClickAction(c_id)

    def doClickAction(self, control_id):
        # Обрабатываем активированные контролы.
        if control_id == self.strlist_id:
            pass
            #
        elif control_id == self.btn_controls["stop_log"]:
            self.stopLog()
            self.setFocus(self.controls["strlist"])
        elif control_id == self.btn_controls["start_log"]:
            self.startLog()
            self.setFocus(self.controls["strlist"])
        elif control_id == self.btn_controls["save"]:
            self.writeFile()
            self.setFocus(self.controls["strlist"])            
        elif control_id == self.btn_controls["exit"]:
            self.close()

    def set_navigation(self):
        pass

    def strlanguage(self, id_str, altstr=""):
        onestr = ""
        try:
            onestr = self.addon.getLocalizedString( id_str )
        except:
            onestr = ""
        if onestr:
            return onestr
        else:
            return altstr
